SystemOrganization addCategory: #DeltaWeb!
SystemOrganization addCategory: #'DeltaWeb-Web'!
SystemOrganization addCategory: #'DeltaWeb-Model'!
SystemOrganization addCategory: #'DeltaWeb-Tests'!

WAFileLibrary subclass: #DWFileLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DeltaWeb-Web'!

!DWFileLibrary methodsFor: 'css' stamp: 'DiegoLont 9/26/2012 15:17'!
mainCss
	^''! !

!DWFileLibrary methodsFor: 'accessing' stamp: 'DiegoLont 9/26/2012 15:17'!
selectorsToInclude
	^#(main.css)! !

WAComponent subclass: #DWDeltawerkenWebtestsApplication
	instanceVariableNames: 'model editForm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DeltaWeb-Web'!

!DWDeltawerkenWebtestsApplication class methodsFor: 'testing' stamp: 'DiegoLont 9/26/2012 15:17'!
canBeRoot
	^true! !

!DWDeltawerkenWebtestsApplication class methodsFor: 'initialization' stamp: 'DiegoLont 9/26/2012 15:19'!
initialize
	"Registers this application as webpage"
	(WAAdmin register: self asApplicationAt: 'DeltaWeb')
		addLibrary: JQDeploymentLibrary;
		addLibrary: JQUiDeploymentLibrary! !

!DWDeltawerkenWebtestsApplication methodsFor: 'accessing' stamp: 'DiegoLont 9/26/2012 16:24'!
cancel
	editForm := nil! !

!DWDeltawerkenWebtestsApplication methodsFor: 'hooks' stamp: 'DiegoLont 9/26/2012 15:35'!
children
	^Array with: self editForm! !

!DWDeltawerkenWebtestsApplication methodsFor: 'accessing' stamp: 'DiegoLont 9/26/2012 16:26'!
editForm
	^editForm ifNil: [ editForm := DEEditForm new
		subject: self model isNew: false;
		saveAction: [ self save ];
		cancelAction: [ self cancel ];
		showAsDiv;
		yourself ]! !

!DWDeltawerkenWebtestsApplication methodsFor: 'accessing' stamp: 'DiegoLont 9/26/2012 16:26'!
model
	^model ifNil: [ model := DWModel new ]! !

!DWDeltawerkenWebtestsApplication methodsFor: 'accessing' stamp: 'DiegoLont 9/26/2012 16:27'!
model: anObject
	^model := anObject! !

!DWDeltawerkenWebtestsApplication methodsFor: 'rendering' stamp: 'DiegoLont 9/26/2012 15:36'!
renderContentOn: canvas
	canvas heading: self title.
	"Insert your custom rendering code here"
	super renderContentOn: canvas! !

!DWDeltawerkenWebtestsApplication methodsFor: 'accessing' stamp: 'DiegoLont 9/26/2012 16:24'!
save
	self model: self editForm subject.
	self cancel! !

!DWDeltawerkenWebtestsApplication methodsFor: 'accessing' stamp: 'DiegoLont 9/26/2012 15:17'!
title
	^'Deltawerken Webtests'! !

!DWDeltawerkenWebtestsApplication methodsFor: 'rendering' stamp: 'DiegoLont 9/26/2012 15:17'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot title: self title.
	anHtmlRoot link
		type: 'text/css';
		beStylesheet;
		addAll;
		url: DWFileLibrary / 'main.css'! !

DEApplicationDescription subclass: #DWApplicationDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DeltaWeb'!

!DWApplicationDescription class methodsFor: 'accessing' stamp: 'DiegoLont 9/26/2012 15:17'!
applicationName
	^'Deltawerken Webtests'! !

!DWApplicationDescription class methodsFor: 'accessing' stamp: 'DiegoLont 9/26/2012 15:17'!
prefix
	^'DW'! !

DEDomainObject subclass: #DWModel
	instanceVariableNames: 'switch demoValue demo2 count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DeltaWeb-Model'!

!DWModel class methodsFor: 'fields' stamp: 'DiegoLont 9/26/2012 16:59'!
demo1Field
	^DEStringField new
		label: 'Comments (as stringfield):';
		accessor: #demoValue;
		yourself! !

!DWModel class methodsFor: 'fields' stamp: 'DiegoLont 9/26/2012 15:32'!
demo1Fields
	^Array with: self demo1Field! !

!DWModel class methodsFor: 'fields' stamp: 'DiegoLont 9/26/2012 16:33'!
demo2Field
	^DEStringField new
		label: 'This field is shown when demo2 is selected:';
		beReadonly;
		accessor: #demo2;
		yourself! !

!DWModel class methodsFor: 'fields' stamp: 'DiegoLont 9/26/2012 15:32'!
demo2Fields
	^Array with: self demo2Field with: self demo3Field! !

!DWModel class methodsFor: 'fields' stamp: 'DiegoLont 9/26/2012 16:59'!
demo3Field
	^DEMemoField new
		label: 'comments (as memofield):';
		accessor: #demoValue;
		yourself! !

!DWModel class methodsFor: 'fields' stamp: 'DiegoLont 9/26/2012 15:34'!
fields
	^#( switchField )! !

!DWModel class methodsFor: 'fields' stamp: 'DiegoLont 9/26/2012 15:37'!
switchField
	^DEConditionalField new
		accessor: #switch;
		label: 'Select your value';
		addFields: self demo1Fields for: #demo1;
		addFields: self demo2Fields for: #demo2;
		yourself! !

!DWModel methodsFor: 'accessing' stamp: 'DiegoLont 9/26/2012 16:30'!
count
	^count ifNil: [ count := 0 ]! !

!DWModel methodsFor: 'accessing' stamp: 'DiegoLont 9/26/2012 16:30'!
demo2
	^demo2! !

!DWModel methodsFor: 'accessing' stamp: 'DiegoLont 9/26/2012 16:28'!
demoValue
	^demoValue! !

!DWModel methodsFor: 'accessing' stamp: 'DiegoLont 9/26/2012 16:29'!
demoValue: aString 
	demoValue := aString! !

!DWModel methodsFor: 'accessing' stamp: 'DiegoLont 9/26/2012 16:31'!
incCount
	count := self count +1.
	^count! !

!DWModel methodsFor: 'accessing' stamp: 'DiegoLont 9/26/2012 15:22'!
switch
	^switch! !

!DWModel methodsFor: 'accessing' stamp: 'DiegoLont 9/26/2012 16:32'!
switch: anObject
	switch = anObject ifFalse: [ 
		switch := anObject.
		demo2 := 'You have switched ', self incCount asString, ' times' ]! !

BPWebDriverTestCase subclass: #DWWebTest
	instanceVariableNames: 'switch'
	classVariableNames: 'default'
	poolDictionaries: ''
	category: 'DeltaWeb-Tests'!

!DWWebTest methodsFor: 'running' stamp: 'DiegoLont 9/26/2012 15:58'!
componentClass
	^DWDeltawerkenWebtestsApplication! !

!DWWebTest methodsFor: 'running' stamp: 'DiegoLont 9/26/2012 16:48'!
configureTestApp: testApp
	super configureTestApp: testApp.
	testApp
		addLibrary: JQDeploymentLibrary;
		addLibrary: JQUiDeploymentLibrary! !

!DWWebTest methodsFor: 'tests' stamp: 'DiegoLont 9/26/2012 16:44'!
testInputValue
	| fieldWidgets span inputDemo |
	fieldWidgets := (driver findElementsByClassName: 'fieldWidget').
	self assert: fieldWidgets size equals: 1.
	inputDemo := fieldWidgets first findElementsByTagName: 'input'.
	self assert: 2 equals: inputDemo size.
	inputDemo first click.
	fieldWidgets := (driver findElementsByClassName: 'fieldWidget').
	self assert: fieldWidgets size equals: 2.
	inputDemo := fieldWidgets first findElementsByTagName: 'input'.
	self assert: inputDemo size equals: 2.
	self halt.! !
DWDeltawerkenWebtestsApplication initialize!
